﻿using System.Runtime.InteropServices;

class Tusbs01cn1
{
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Device_Open(short id);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs01cn1_Device_Close(short id);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Counter_Read(short id, out int DataH, out int DataL);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Counter_Enable(short id);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Counter_Disable(short id);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Counter_Clear(short id);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Counter_Control(short id, byte EnaSel, byte ClrSel, byte CntDir);
    [DllImport("TUSBSCN1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01cn1_Input_Read(short id, byte cnt_mon, byte ena_mon, byte clr_mon);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

