﻿Public Class Form1
    Const DevId As Short = 0 ' デバイスIDを0とする

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim retcode As Short
        retcode = Tusbs01cn1_Device_Open(DevId)
        If retcode <> 0 Then 'デバイスオープン
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
        Else
            StopBtn.Checked = True '初めは停止中
            CntDirUp.Checked = True 'Upでカウント
            ControlInt.Checked = True '内部制御
            ClearInt.Checked = True 'クリア内部信号

            retcode = Tusbs01cn1_Counter_Disable(DevId)
            If retcode <> 0 Then
                MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
                Me.Close()
                Exit Sub
            End If

            retcode = Tusbs01cn1_Counter_Control(DevId, 2, 2, 0)
            If retcode <> 0 Then
                MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
                Me.Close()
                Exit Sub
            End If
        End If
        Timer1.Enabled = True 'タイマー開始
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        Tusbs01cn1_Device_Close(DevId)
    End Sub

    Private Sub StartBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartBtn.CheckedChanged
        Dim retcode As Short
        retcode = Tusbs01cn1_Counter_Enable(DevId)
        If retcode <> 0 Then
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
            Exit Sub
        End If
    End Sub

    Private Sub StopBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopBtn.CheckedChanged
        Dim retcode As Short
        retcode = Tusbs01cn1_Counter_Disable(DevId)
        If retcode <> 0 Then
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
            Exit Sub
        End If
    End Sub

    Private Sub ClearBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearBtn.Click
        Dim retcode As Short
        retcode = Tusbs01cn1_Counter_Clear(DevId)
        If retcode <> 0 Then
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
            Exit Sub
        End If
    End Sub
    Private Sub CounterSet()
        Dim retcode As Short
        Dim EnaSel As Byte
        Dim ClrSel As Byte
        Dim CntDir As Byte

        If ControlExPos.Checked Then
            EnaSel = 0
        ElseIf ControlExNeg.Checked Then
            EnaSel = 1
        Else
            EnaSel = 2
        End If

        If ClearExUp.Checked Then
            ClrSel = 0
        ElseIf ClearExDown.Checked Then
            ClrSel = 1
        Else
            ClrSel = 2
        End If

        If CntDirUp.Checked Then
            CntDir = 0
        Else
            CntDir = 1
        End If

        retcode = Tusbs01cn1_Counter_Control(DevId, EnaSel, ClrSel, CntDir)
        If retcode <> 0 Then
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
            Exit Sub
        End If
    End Sub
    Private Sub CntDirUp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CntDirUp.CheckedChanged
        If CntDirUp.Checked Then
            CounterSet()
        End If
    End Sub

    Private Sub CntDirDown_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CntDirDown.CheckedChanged
        If CntDirDown.Checked Then
            CounterSet()
        End If
    End Sub

    Private Sub ControlExPos_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ControlExPos.CheckedChanged
        If sender.Checked Then
            StartBtn.Enabled = False
            StopBtn.Enabled = False
            CounterSet()
        End If
    End Sub

    Private Sub ControlExNeg_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ControlExNeg.CheckedChanged
        If sender.Checked Then
            StartBtn.Enabled = False
            StopBtn.Enabled = False
            CounterSet()
        End If
    End Sub

    Private Sub ControlInt_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ControlInt.CheckedChanged
        If sender.Checked Then
            StartBtn.Enabled = True
            StopBtn.Enabled = True
            CounterSet()
        End If
    End Sub

    Private Sub ClearExUp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearExUp.CheckedChanged
        If sender.Checked Then
            ClearBtn.Enabled = False
            CounterSet()
        End If
    End Sub

    Private Sub ClearExDown_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearExDown.CheckedChanged
        If sender.Checked Then
            ClearBtn.Enabled = False
            CounterSet()
        End If
    End Sub

    Private Sub ClearInt_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearInt.CheckedChanged
        If sender.Checked Then
            ClearBtn.Enabled = True
            CounterSet()
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim retcode As Short
        Dim DataH As Integer
        Dim DataL As Integer
        Dim tmpN As Decimal

        retcode = Tusbs01cn1_Counter_Read(DevId, DataH, DataL)
        If retcode <> 0 Then
            MessageBox.Show(Tusbs01cn1_GetErrMessage(retcode))
            Me.Close()
            Exit Sub
        Else
            tmpN = DataL
            tmpN = tmpN + CDec(DataH) * &H10000
            CountDisp.Text = tmpN.ToString()
        End If
    End Sub


End Class
