﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S01CN1Sample
{
    public partial class Form1 : Form
    {
        const short DevId = 0; //デバイスIDは0固定

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short retcode;
            if ((retcode = Tusbs01cn1.Tusbs01cn1_Device_Open(DevId)) != 0)
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
            }
            else
            {
                StopBtn.Checked = true;//初めは停止中
                CntDirUp.Checked = true;//Upでカウント
                ControlInt.Checked = true;//内部制御
                ClearInt.Checked = true;//クリア内部信号

                if ((retcode = Tusbs01cn1.Tusbs01cn1_Counter_Disable(DevId)) != 0)
                {
                    MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                    this.Close();
                    return;
                }

                if ((retcode = Tusbs01cn1.Tusbs01cn1_Counter_Control(DevId, 2, 2, 0)) != 0)
                {
                    MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                    this.Close();
                    return;
                }
            }
            Timer1.Enabled = true;//タイマー開始
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            Tusbs01cn1.Tusbs01cn1_Device_Close(DevId);
        }

        private void StartBtn_CheckedChanged(object sender, EventArgs e)
        {
            short retcode;
            if( (retcode = Tusbs01cn1.Tusbs01cn1_Counter_Enable(DevId)) != 0 )
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
                return;
            }
        }

        private void StopBtn_CheckedChanged(object sender, EventArgs e)
        {
            short retcode;
            if ((retcode = Tusbs01cn1.Tusbs01cn1_Counter_Disable(DevId)) != 0)
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
                return;
            }
        }

        private void ClearBtn_Click(object sender, EventArgs e)
        {
            short retcode;
            if( (retcode = Tusbs01cn1.Tusbs01cn1_Counter_Clear(DevId)) != 0 )
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
                return;
            }
        }
        private void CounterSet()
        {
            short retcode;
            byte EnaSel;
            byte ClrSel;
            byte CntDir;

            if (ControlExPos.Checked)
                EnaSel = 0;
            else if (ControlExNeg.Checked)
                EnaSel = 1;
            else
                EnaSel = 2;

            if (ClearExUp.Checked)
                ClrSel = 0;
            else if (ClearExDown.Checked)
                ClrSel = 1;
            else
                ClrSel = 2;

            if (CntDirUp.Checked)
                CntDir = 0;
            else
                CntDir = 1;

            if ((retcode = Tusbs01cn1.Tusbs01cn1_Counter_Control(DevId, EnaSel, ClrSel, CntDir)) != 0)
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
                return;
            }
        }

        private void CntDirUp_CheckedChanged(object sender, EventArgs e)
        {
            if ( CntDirUp.Checked )
            {
                CounterSet();
            }
        }

        private void CntDirDown_CheckedChanged(object sender, EventArgs e)
        {
            if (CntDirDown.Checked)
            {
                CounterSet();
            }
        }

        private void ControlExPos_CheckedChanged(object sender, EventArgs e)
        {
            if( ControlExPos.Checked )
            {
                StartBtn.Enabled = false;
                StopBtn.Enabled = false;
                CounterSet();
            }
        }

        private void ControlExNeg_CheckedChanged(object sender, EventArgs e)
        {
            if (ControlExNeg.Checked)
            {
                StartBtn.Enabled = false;
                StopBtn.Enabled = false;
                CounterSet();
            }
        }

        private void ControlInt_CheckedChanged(object sender, EventArgs e)
        {
            if (ControlInt.Checked)
            {
                StartBtn.Enabled = true;
                StopBtn.Enabled = true;
                CounterSet();
            }
        }

        private void ClearExUp_CheckedChanged(object sender, EventArgs e)
        {
            if (ClearExUp.Checked)
            {
                ClearBtn.Enabled = false;
                CounterSet();
            }
        }

        private void ClearExDown_CheckedChanged(object sender, EventArgs e)
        {
            if (ClearExDown.Checked)
            {
                ClearBtn.Enabled = false;
                CounterSet();
            }
        }

        private void ClearInt_CheckedChanged(object sender, EventArgs e)
        {
            if (ClearInt.Checked)
            {
                ClearBtn.Enabled = true;
                CounterSet();
            }
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            short retcode;
            int DataH;
            int DataL;
            decimal tmpN;

            if ((retcode = Tusbs01cn1.Tusbs01cn1_Counter_Read(DevId, out DataH, out DataL)) != 0)
            {
                MessageBox.Show(Tusbs01cn1.GetErrMessage(retcode));
                this.Close();
                return;
            }
            else
            {
                tmpN = DataL;
                tmpN = tmpN + (decimal)DataH * 0x10000;
                CountDisp.Text = tmpN.ToString();
            }
        }
    }
}
